<template>
    <v-card class="my-2">
        <v-card-text primary-title>
            <div>
                <v-avatar
                        v-if="message.author && message.author.userpic"
                        size="48px"
                >
                    <img
                            :src="message.author.userpic"
                            :alt="message.author.name"
                    >
                </v-avatar>

                <v-avatar
                        v-else
                        size="48px"
                        color="orange"
                >
                    <v-icon dark>{{ accountIcon }}</v-icon>
                </v-avatar>
                <span class="pl-3">{{ authorName }}</span>
            </div>
            <div class="pt-3">
                {{ message.text }}
            </div>
        </v-card-text>
        <media v-if="message.link" :message="message"></media>
        <v-card-actions v-if="authorId" >
            <v-btn value="Edit" @click="edit" text small rounded color="orange">Edit</v-btn>
            <v-btn icon @click="del" small>
                <v-icon>{{ deleteRow }}</v-icon>
            </v-btn>
        </v-card-actions>
        <comment-list
            :comments="message.comments"
            :message-id="message.id"
        ></comment-list>
    </v-card>
</template>

<script>
  import { mapActions } from 'vuex'
  import { mdiDelete } from '@mdi/js';
  import { mdiAccountOutline } from '@mdi/js';
  import Media from 'components/media/Media.vue'
  import CommentList from '../comment/CommentList.vue'

  export default {
    data() {
      return {
        deleteRow: mdiDelete,
        accountIcon: mdiAccountOutline
      }
    },
    props: ['message', 'editMessage', 'profileId'],
    components: { CommentList, Media },
    computed: {
      authorName() {
        return this.message.author.name ? this.message.author.name : 'unknown'
      } ,
      authorId() {
        return !!(this.message.author.id && this.message.author.id === this.profileId)
      }
    },
    methods: {
      ...mapActions(['removeMessageAction']),
      edit() {
        this.editMessage(this.message)
      },
      del() {
        this.removeMessageAction(this.message)
      }
    }
  }
</script>

<style>

</style>
